标签:
Given a binary search tree (BST), find the lowest common ancestor (LCA) of two given nodes in the BST.
According to the definition of LCA on Wikipedia: “The lowest common ancestor is defined between two nodes v and w as the lowest node in T that has both v and w as descendants (where we allow a node to be a descendant of itself).”
_______6______ / ___2__ ___8__ / \ / 0 _4 7 9 / 3 5
For example, the lowest common ancestor (LCA) of nodes 2
and 8
is 6
. Another example is LCA of nodes 2
and 4
is 2
, since a node can be a descendant of itself according to the LCA definition.
分析:由于在所谓的二叉搜索树(binary search tree)中,处处满足顺序性(即任一节点的左(右)子树种,所有节点均小于(大于)r)。
思路: 1、当头结点为空时,返回空指针
2、如果节点p、q的值都比root的值要小,那么LCA一定为root的左子树;而如果节点p、q的值都比root的值要大,那么LCA一定为root的右子树;当节点p、q的值中一个比root的值要大,另一个比它小时,LCA就是root了。
3、我们要考虑是否能覆盖到节点是它自身子节点的情况,这时返回的是p或q的其中一个。
代码如下:(recursive solution)
/** * Definition for a binary tree node. * struct TreeNode { * int val; * TreeNode *left; * TreeNode *right; * TreeNode(int x) : val(x), left(NULL), right(NULL) {} * }; */ class Solution { public: TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) { while(root !=nullptr){ if(p->val < root->val && q->val < root->val){ return lowestCommonAncestor(root->left,p,q); } else if(p->val > root->val && q->val > root->val){ return lowestCommonAncestor(root->right,p,q); } else return root; // 当p->val = root->val或 q->val =root->val时,就是节点是它自身子节点的情况了
}
return root;
}
};
也可以简洁点:
class Solution { public: TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) { if (p -> val < root -> val && q -> val < root -> val) return lowestCommonAncestor(root -> left, p, q); if (p -> val > root -> val && q -> val > root -> val) return lowestCommonAncestor(root -> right, p, q); return root; } };
其他参考解法:
class Solution { public: TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) { if(p->val > root->val && q->val < root->val) { return root; } if(p->val < root->val && q->val > root->val) { return root; } if( p->val == root->val || q->val == root->val) return root; if( p->val < root->val && q->val < root->val) return lowestCommonAncestor(root->left, p, q); if( p->val > root->val && q->val > root->val) return lowestCommonAncestor(root->right, p, q); } };
或:(iterative solution)
class Solution { public: TreeNode* lowestCommonAncestor(TreeNode* root, TreeNode* p, TreeNode* q) { TreeNode* cur = root; while (true) { if (p -> val < cur -> val && q -> val < cur -> val) cur = cur -> left; else if (p -> val > cur -> val && q -> val > cur -> val) cur = cur -> right; else return cur; } } };
leetcode:Lowest Common Ancestor of a Binary Search Tree
标签:
原文地址:http://www.cnblogs.com/carsonzhu/p/4653793.html